//
// Copyright (c) 2011 Naoki Hiroshima / naan studio, Inc. ALL RIGHTS RESERVED.
//

var EXPORTED_SYMBOLS = ["EchofonGA"];

const ACCOUNT   = 'UA-565580-23';
const VERSION   = '4.9.1';
const GIF       = 'http://www.google-analytics.com/__utm.gif?';
const HOSTNAME  = 'firefox.echofon.com'

const Cc = Components.classes;
const Ci = Components.interfaces;

Components.utils.import("resource://echofon/EchofonUtils.jsm");

var language, colorDepth, screenResolution;
var characterSet = 'UTF-8';
var javaEnabled = 1;
var flashVersion = '10.1 r102';
var pageTitle = 'Echofon'

var domainHash = '101498262';
var uuid = EchofonUtils.pref().getIntPref("activeUserId");
var sessFirst = +new Date();
var sessLast = sessFirst;
var sessCount = 0;

function makeTrackingURL(params) {
  var sessCurrent = +new Date();
  sessCount++;

  var utma = domainHash +'.'+ uuid +'.'+ sessFirst +'.'+ sessLast +'.'+ sessCurrent +'.'+ sessCount;
  var utmcc = '__utma=' + utma + ';';

  sessLast = sessCurrent;

  var params_ = {
    'utmac':  ACCOUNT,
    'utmwv':  VERSION,
    'utmhn':  HOSTNAME,
    'utmcc':  utmcc,
    'utmul':  language,  // en-US
    'utmcs':  characterSet,  // iso-8859-1
    'utmsr':  screenResolution,  // 1680x1050
    'utmsc':  colorDepth,  // 24-bit
    'utmp':   '/',
    'utmr':   '-',
    'utmje':  javaEnabled,
    'utmfl':  flashVersion,
    'utmdt':  pageTitle,
    'utmn':   Math.floor(Math.random() * 0x7fffffff),
    'utmhid': Math.floor(Math.random() * 0x7fffffff)
  };
  if (params['page']) {
    params_['utmp'] = params['page'];
    if (params['referer']) {
      params_['utmr'] = params['referer'];
    }
  }
  if (params['event']) {
    params_['utmt'] = 'event';
    params_['utme'] = params['event'];
    params_['utmr'] = 0;
  }

  var query = ''
  for (var i in params_) {
    query += i + '=' + encodeURIComponent(params_[i]) + '&';
  }
  return GIF + query;
}

function EchofonGA() {
  var localeService = Cc["@mozilla.org/intl/nslocaleservice;1"].getService(Ci.nsILocaleService);
  var screenManager = Cc["@mozilla.org/gfx/screenmanager;1"].getService(Ci.nsIScreenManager);

  var left = {}, top = {}, width = {}, height = {};
  screenManager.primaryScreen.GetRect(left, top, width, height);

  screenResolution = width.value + 'x' + height.value;
  colorDepth = screenManager.primaryScreen.colorDepth + '-bit';
  language = localeService.getApplicationLocale().getCategory("NSILOCALE_CTYPE");

  this.timer = Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer);
  this.timer.initWithCallback(
    {notify: function() {
        var pref = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService).getBranch("extensions.twitternotifier.");
        if (pref.getBoolPref("login")) {
          EchofonGA.instance().trackEvent("app", "keep alive", pref.getCharPref("applicationMode"), 0);
        }
      }
    },
    24 * 60 * 60 * 1000,
    Ci.nsITimer.TYPE_REPEATING_SLACK);
}

EchofonGA.prototype = {

  sendRequest: function(url) {
    let request = Cc["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Ci.nsIXMLHttpRequest);
    request.open("GET", url, true);
    request.send(null)
  },

  trackPage: function(page) {
    var url = makeTrackingURL({'page':page});
    this.sendRequest(url);
    return url;
  },

  trackEvent: function(category, action, label, value) {
    var event = '5('+category+'*'+action;
    if (label) event += '*'+label;
    if (value) event += ')('+value;
    event += ')';
    var url = makeTrackingURL({'event':event});
    this.sendRequest(url);
    return url;
  }
}

var gEchofonGA = null;

EchofonGA.instance = function() {
  if (gEchofonGA == null) {
    gEchofonGA = new EchofonGA();
  }
  return gEchofonGA;
}
